;     Ŀ
;        Sound Deluxe System 5, a Maple Leaf production               
;        1996-1997                                                    
;           
;        Memory allocation/deallocation routines (using INT21)        
;     

MemAlloc proc    near   ; In:   BX = nr. of paragraphs to allocate
                        ; Out:  AX = segment of allocated memory block
        mov      ax,4800h
        clc
        int      21h
        jc       @err1
        call     CheckBoundary  ; ckecks if DMA page boundary crossed or not
        clc
        retn
@err1:  stc      ; Shit !
        retn
MemAlloc endp

CheckBoundary proc near

        push    cx ax

        mov     cx,ax
        add     cx,bx     ; ax = StartSeg, cx = EndSeg
        and     ax,0F000h
        and     cx,0F000h
        cmp     ax,cx     ; the same fuckin page ?
        pop     ax
        jne     @Realloc

        pop     cx

        retn

@Realloc:

  ; The page boundary has been crossed. Try to reallocate the buffer.
  ; In order to do this, the routine will deallocate the buffer, then
  ; it will alloc two memory areas, first just to "fill up" the DMA page,
  ; and the second - our resultant buffer.

        push    ax es
        mov     es,ax   ; StartSeg
        mov     ah,49h
        int     21h     ; deallocate block
        pop     es ax

        push    bx        ; save size (in paragraphs)

        mov     cx,ax     ; cx=StartSeg
        add     cx,bx     ; cx=EndSeg
        and     cx,0F000h ; cx=EndSeg and F000h
        sub     cx,ax     ; cx=(EndSeg and F000h)-StartSeg = "fill up" size (in paragraphs)

        mov     bx,cx
        mov     ah,48h
        int     21h       ; alloc the "fill-up" area

        mov     cx,ax     ; save the "fill-up" start segment in CX

        pop     bx        ; restore size

        call    MemAlloc  ; recursive call... I hope it won't freeze...

    ; now we have the segment of our buffer in AX, so deallocate the
    ; "fill-up" buffer

        push    ax
        mov     bx,cx
        call    MemFree
        pop     ax

        pop     cx

        retn
CheckBoundary endp

MemFree proc    near    ; In:  BX = segment of the memory block
                        ; Out: A big looking shit
        push    es
        mov     es,bx
        mov     ax,4900h
        clc
        int     21h
        ; Suppose everything is okay ...
        pop     es
        retn
MemFree endp
